# ApiGenTask

Extends \Task

ApiGen task (http://apigen.org).

Use \Project#createTask to register a new Task.

package | phing.tasks.ext.apigen
author | Martin Srank martin@smasty.net
author | Jaroslav Hanslík kukulich@kukulich.cz
since | 2.4.10

### Methods

## Generates command line arguments for the ApiGen executable.

    constructArguments() : string

### Response

`string`

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## Sets the element access levels.

    setAccessLevels(string $accessLevels)

Documentation only for methods and properties with the given access level will be generated.

### Arguments

#### $accessLevels

`string`

## Sets a list of HTML tags allowed in the documentation.

    setAllowedHtml(string $allowedHtml)

### Arguments

#### $allowedHtml

`string`

## Sets element types for search input autocomplete.

    setAutocomplete(string $autocomplete)

### Arguments

#### $autocomplete

`string`

## Sets the documentation base URL.

    setBaseUrl(string $baseUrl)

### Arguments

#### $baseUrl

`string`

## Sets the character set of source files.

    setCharset(string $charset)

### Arguments

#### $charset

`string`

## Sets the config file name.

    setConfig(string $config)

### Arguments

#### $config

`string`

## Enables/disables the debug mode.

    setDebug(boolean $debug)

### Arguments

#### $debug

`boolean`

## Sets if documentation for deprecated elements should be generated.

    setDeprecated(boolean $deprecated)

### Arguments

#### $deprecated

`boolean`

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## Sets the destination directory.

    setDestination(string $destination)

### Arguments

#### $destination

`string`

## Sets if a link to download documentation as a ZIP archive should be generated.

    setDownload(boolean $download)

### Arguments

#### $download

`boolean`

## Sets masks (case sensitive) to exclude files or directories from processing.

    setExclude(string $exclude)

### Arguments

#### $exclude

`string`

## Sets the ApiGen executable name.

    setExecutable(string $executable)

### Arguments

#### $executable

`string`

## Sets list of allowed file extensions.

    setExtensions(string $extensions)

### Arguments

#### $extensions

`string`

## Sets the Google Analytics tracking code.

    setGoogleAnalytics(string $googleAnalytics)

### Arguments

#### $googleAnalytics

`string`

## Sets the Google Custom Search ID.

    setGoogleCseId(string $googleCseId)

### Arguments

#### $googleCseId

`string`

## Sets the Google Custom Search label.

    setGoogleCseLabel(string $googleCseLabel)

### Arguments

#### $googleCseLabel

`string`

## Sets how elements should be grouped in the menu.

    setGroups(string $groups)

### Arguments

#### $groups

`string`

## Sets if documentation for elements marked as internal and internal documentation parts should be generated.

    setInternal(boolean $internal)

### Arguments

#### $internal

`boolean`

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the main project name prefix.

    setMain(string $main)

### Arguments

#### $main

`string`

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## Sets if documentation for PHP internal classes should be generated.

    setPhp(boolean $php)

### Arguments

#### $php

`boolean`

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Enables/disables scaning and generating messages.

    setQuiet(boolean $quiet)

### Arguments

#### $quiet

`boolean`

## Sets a file name for checkstyle report of poorly documented elements.

    setReport(string $report)

### Arguments

#### $report

`string`

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets masks to exclude elements from documentation generating.

    setSkipDocPath(string $skipDocPath)

### Arguments

#### $skipDocPath

`string`

## Sets a name prefix to exclude elements from documentation generating.

    setSkipDocPrefix(string $skipDocPrefix)

### Arguments

#### $skipDocPrefix

`string`

## Sets source files or directories.

    setSource(string $source)

### Arguments

#### $source

`string`

## Sets if highlighted source code files should be generated.

    setSourceCode(boolean $sourceCode)

### Arguments

#### $sourceCode

`boolean`

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## Sets the template config file name.

    setTemplateConfig(string $templateConfig)

### Arguments

#### $templateConfig

`string`

## Sets the title of generated documentation.

    setTitle(string $title)

### Arguments

#### $title

`string`

## Sets if documentation of tasks should be generated.

    setTodo(boolean $todo)

### Arguments

#### $todo

`boolean`

## Sets if tree view of classes, interfaces, traits and exceptions should be generated.

    setTree(boolean $tree)

### Arguments

#### $tree

`boolean`

## Enables/disables the check for ApiGen updates.

    setUpdateCheck(boolean $updateCheck)

### Arguments

#### $updateCheck

`boolean`

## Sets if the destination directory should be wiped out first.

    setWipeout(boolean $wipeout)

### Arguments

#### $wipeout

`boolean`

### Properties

## Default ApiGen executable name.

    executable : string

var |

### Type(s)

`string`

## Default options for ApiGen.

    options : array

var |

### Type(s)

`array`

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`